import { FieldValue, GrpcStatus } from 'firebase-admin/firestore';
import { App, DocumentData, DocumentReference, DocumentSnapshot, QuerySnapshot, WriteDocumentData } from './type';
export declare const firestore: {
    FieldValue: typeof FieldValue;
    GrpcStatus: typeof GrpcStatus;
};
/**
 * Type safe and convenience firebase-admin wrapper
 */
declare function getDocRef(app: App, collectionName: string, documentId: string): DocumentReference;
export declare function getDoc(app: App, collectionName: string, documentId: string): Promise<DocumentSnapshot>;
export declare function deleteDoc(app: App, collectionName: string, documentId: string): Promise<FirebaseFirestore.WriteResult>;
export declare function createDoc(app: App, collectionName: string, documentId: string, data: DocumentData): Promise<FirebaseFirestore.WriteResult>;
export declare function updateDoc(app: App, collectionName: string, documentId: string, data: WriteDocumentData): Promise<FirebaseFirestore.WriteResult>;
export declare function getCollection(app: App, collectionName: string, query?: (collectionRef: FirebaseFirestore.CollectionReference<DocumentData>) => FirebaseFirestore.Query<DocumentData>): Promise<QuerySnapshot>;
export declare const _: {
    getDocRef: typeof getDocRef;
};
export {};
//# sourceMappingURL=firebase-admin.d.ts.map