"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports._ = exports.getCollection = exports.updateDoc = exports.createDoc = exports.deleteDoc = exports.getDoc = exports.firestore = void 0;
/* eslint-disable no-restricted-imports */
const firestore_1 = require("firebase-admin/firestore");
const util_1 = require("./util");
exports.firestore = { FieldValue: firestore_1.FieldValue, GrpcStatus: firestore_1.GrpcStatus };
/**
 * Type safe and convenience firebase-admin wrapper
 */
function getDocRef(app, collectionName, documentId) {
    app;
    return (0, firestore_1.getFirestore)().collection(collectionName).doc(documentId);
}
async function getDoc(app, collectionName, documentId) {
    const snapshot = await exports._.getDocRef(app, collectionName, documentId).get();
    const wrappedSnapshot = (0, util_1.wrapFirebaseSnapshot)(snapshot);
    return wrappedSnapshot;
}
exports.getDoc = getDoc;
function deleteDoc(app, collectionName, documentId) {
    return exports._.getDocRef(app, collectionName, documentId).delete();
}
exports.deleteDoc = deleteDoc;
function createDoc(app, collectionName, documentId, data) {
    return exports._.getDocRef(app, collectionName, documentId).create(data);
}
exports.createDoc = createDoc;
function updateDoc(app, collectionName, documentId, data) {
    return exports._.getDocRef(app, collectionName, documentId).update(data);
}
exports.updateDoc = updateDoc;
async function getCollection(app, collectionName, query) {
    const collectionRef = (0, firestore_1.getFirestore)(app).collection(collectionName);
    const collectionQuery = query === undefined ? collectionRef : query(collectionRef);
    const snapshot = await collectionQuery.get();
    const wrappedDocs = snapshot.docs.map(util_1.wrapFirebaseSnapshot);
    const wrappedQuerySnapshot = {
        docs: wrappedDocs,
    };
    return wrappedQuerySnapshot;
}
exports.getCollection = getCollection;
exports._ = { getDocRef };
//# sourceMappingURL=firebase-admin.js.map