import { App, CollectionSpec, CollectionTriggers, Dict, DocumentSnapshot, ViewSpec } from './type';
/**
 * Materialize and create a view document based on given specification.
 *
 * @param app Firebase app.
 * @param collectionName Name of the view's collection.
 * @param viewName Name of the view.
 * @param srcDoc Document snapshot of the view's source document
 * @param viewSpec Specification of the view.
 * @returns Creation result of the view document.
 */
export declare function createViewDoc(app: App, collectionName: string, viewName: string, srcDoc: DocumentSnapshot, viewSpec: ViewSpec): Promise<FirebaseFirestore.WriteResult>;
/**
 * Make triggers for masmott.
 *
 * @param app Firebase app.
 * @param collectionSpecs Collections specs of the app.
 * @returns Triggers made by masmott.
 */
export declare function makeMasmottTriggers(app: App, collectionSpecs: Dict<CollectionSpec>): Dict<CollectionTriggers>;
//# sourceMappingURL=get-trigger.d.ts.map